diff --git a/src/main/java/net/minecraft/core/entity/animal/SquidMob.java b/src/main/java/net/minecraft/core/entity/animal/SquidMob.java
new file mode 100644
index 000000000..1ee9c5d3a
--- /dev/null
+++ b/src/main/java/net/minecraft/core/entity/animal/SquidMob.java
@@ -0,0 +1,217 @@
+package net.minecraft.core.entity.animal;
+
+// Referenced classes of package net.minecraft.src:
+//            EntityWaterMob, ItemStack, Item, AxisAlignedBB, 
+//            Material, World, MathHelper, NBTTagCompound, 
+//            Player
+
+import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+public class SquidMob extends WaterAnimal
+{
+    public float xBodyRot;
+    public float xBodyRotO;
+    public float zBodyRot;
+    public float zBodyRotO;
+    public float tentacleMovement;
+    public float oldTentacleMovement;
+    public float tentacleAngle;
+    public float oldTentacleAngle;
+    private float _speed;
+    private float tentacleSpeed;
+    private float rotateSpeed;
+    private float tx;
+    private float ty;
+    private float tz;
+
+    public SquidMob(World world)
+    {
+        super(world);
+        xBodyRot = 0.0F;
+        xBodyRotO = 0.0F;
+        zBodyRot = 0.0F;
+        zBodyRotO = 0.0F;
+        tentacleMovement = 0.0F;
+        oldTentacleMovement = 0.0F;
+        tentacleAngle = 0.0F;
+        oldTentacleAngle = 0.0F;
+        _speed = 0.0F;
+        tentacleSpeed = 0.0F;
+        rotateSpeed = 0.0F;
+        tx = 0.0F;
+        ty = 0.0F;
+        tz = 0.0F;
+        isInWater();
+        textureIdentifier = new NamespaceID("minecraft", "squid");
+        setSize(0.95F, 0.95F);
+        tentacleSpeed = (1.0F / (random.nextFloat() + 1.0F)) * 0.2F;
+        mobDrops.add(new WeightedRandomLootObject(Items.DYE.getDefaultStack(), 1, 3));
+    }
+
+    @Override
+	protected String getHurtSound()
+    {
+        return null;
+    }
+
+    @Override
+	protected String getDeathSound()
+    {
+        return null;
+    }
+
+    @Override
+	public void onLivingUpdate()
+    {
+        super.onLivingUpdate();
+        xBodyRotO = xBodyRot;
+        zBodyRotO = zBodyRot;
+        oldTentacleMovement = tentacleMovement;
+        oldTentacleAngle = tentacleAngle;
+        tentacleMovement += tentacleSpeed;
+        if(tentacleMovement > MathHelper.PI * 2)
+        {
+            tentacleMovement = 0;
+            if(random.nextInt(10) == 9)
+            {
+                tentacleSpeed = (1.0F / (random.nextFloat() + 1.0F)) * 0.2F;
+            }
+        }
+        if(isInWater())
+        {
+            if(tentacleMovement < MathHelper.PI) // Speed burst
+            {
+                float f = tentacleMovement / MathHelper.PI; // 0-1
+                tentacleAngle = MathHelper.sin(f * f * MathHelper.PI) * MathHelper.PI * 0.25F;
+                if((double)f > 0.75D)
+                {
+                    _speed = 1.0F;
+                    rotateSpeed = 1.0F;
+                } else
+                {
+                    rotateSpeed *= 0.8F;
+                }
+            } else // Drift
+            {
+                tentacleAngle = 0.0F;
+                _speed *= 0.9F;
+                rotateSpeed *= 0.99F;
+            }
+            if(!isMultiplayerEntity)
+            {
+                xd = tx * _speed;
+                yd = ty * _speed;
+                zd = tz * _speed;
+            }
+            float horizontalSpeed = MathHelper.sqrt(xd * xd + zd * zd);
+            yBodyRot += ((-(float) Math.atan2(xd, zd) * 180F) / MathHelper.PI - yBodyRot) * 0.1F;
+            yRot = yBodyRot;
+            zBodyRot += MathHelper.PI * rotateSpeed * 1.5F;
+            xBodyRot += ((-(float) Math.atan2(horizontalSpeed, yd) * 180F) / MathHelper.PI - xBodyRot) * 0.1F;
+        } else
+        {
+            tentacleAngle = MathHelper.abs(MathHelper.sin(tentacleMovement)) * MathHelper.PI * 0.25F;
+
+            if(!isMultiplayerEntity)
+            {
+                xd = 0.0D;
+                yd -= 0.08D;
+                yd *= 0.98D;
+                zd = 0.0D;
+            }
+            xBodyRot += (double)(-90F - xBodyRot) * 0.02D;
+        }
+    }
+    @Override
+    public void trySuffocate(){
+        if(isAlive() && !isUnderLiquid(Material.water) && canBreatheUnderwater())
+        {
+            airSupply--;
+            if(airSupply == -20)
+            {
+                airSupply = 0;
+                hurt(null, 2, DamageType.DROWN);
+            }
+            remainingFireTicks = 0;
+        } else
+        {
+            airSupply = airMaxSupply;
+        }
+    }
+
+    @Override
+	public void moveEntityWithHeading(float moveStrafing, float moveForward)
+    {
+        move(xd, yd, zd);
+    }
+
+    @Override
+	protected void updateAI()
+    {
+        if(random.nextInt(50) == 0 || !wasInWater || tx == 0.0F && ty == 0.0F && tz == 0.0F)
+        {
+            float f = random.nextFloat() * MathHelper.PI * 2.0F;
+            tx = MathHelper.cos(f) * 0.2F;
+            Block upwardsBlock = world.getBlock((int) x, (int) y + 3, (int) z);
+            Block downwardsBlock = world.getBlock((int) x, (int) y - 3, (int) z);
+
+            boolean isTouchingBlock = isTouchingBlock();
+
+            if (isTouchingBlock && isInWater() && !world.isAirBlock((int) x, (int) (y + 1), (int) z) && !world.isAirBlock((int) x, (int) (y + 2), (int) z)){
+                ty = random.nextFloat() * 0.2F;
+            } else {
+                if (upwardsBlock == null || upwardsBlock.blockMaterial != Material.water){
+                    ty = -0.15F + random.nextFloat() * 0.2F; // Swim with bias down
+                } else if (downwardsBlock == null || downwardsBlock.blockMaterial != Material.water) {
+                    ty = -0.05F + random.nextFloat() * 0.4F; // Swim with bias up
+                } else {
+                    ty = -0.1F + random.nextFloat() * 0.2F; // Swim with no bias
+                }
+            }
+
+            tz = MathHelper.sin(f) * 0.2F;
+        }
+        tryToDespawn();
+    }
+    public boolean isTouchingBlock(){
+        int minX = MathHelper.floor(bb.minX - 0.25D);
+        int minY = MathHelper.floor(bb.minY - 0.25D);
+        int minZ = MathHelper.floor(bb.minZ - 0.25D);
+        int maxX = MathHelper.floor(bb.maxX + 0.25D);
+        int maxY = MathHelper.floor(bb.maxY + 0.25D);
+        int maxZ = MathHelper.floor(bb.maxZ + 0.25D);
+        if(world.areBlocksLoaded(minX, minY, minZ, maxX, maxY, maxZ))
+        {
+            for(int _x = minX; _x <= maxX; _x++)
+            {
+                for(int _y = minY; _y <= maxY; _y++)
+                {
+                    for(int _z = minZ; _z <= maxZ; _z++)
+                    {
+                        int blockId = world.getBlockId(_x, _y, _z);
+                        if(blockId != 0 && Block.blocksList[blockId].blockMaterial != Material.water)
+                        {
+                            return true;
+                        }
+                    }
+
+                }
+
+            }
+
+        }
+        return false;
+    }
+    
+    @Override
+    protected boolean makeStepSound() {
+    	return false;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityWaterAnimal.java b/src/main/java/net/minecraft/core/entity/animal/WaterAnimal.java
similarity index 76%
rename from src/main/java/net/minecraft/core/entity/animal/EntityWaterAnimal.java
rename to src/main/java/net/minecraft/core/entity/animal/WaterAnimal.java
index 4c2536454..7d2f316b4 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityWaterAnimal.java
+++ b/src/main/java/net/minecraft/core/entity/animal/WaterAnimal.java
@@ -4,15 +4,15 @@ package net.minecraft.core.entity.animal;
 // Referenced classes of package net.minecraft.src:
 //            EntityCreature, World, NBTTagCompound
 
-import net.minecraft.core.entity.EntityPathfinder;
+import net.minecraft.core.entity.PathfinderMob;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
 
-public class EntityWaterAnimal extends EntityPathfinder
-	implements IAnimal
+public class WaterAnimal extends PathfinderMob
+	implements Creature
 {
 
-    public EntityWaterAnimal(World world)
+    public WaterAnimal(World world)
     {
         super(world);
         scoreValue = 10;
@@ -37,13 +37,13 @@ public class EntityWaterAnimal extends EntityPathfinder
     }
 
     @Override
-	public boolean getCanSpawnHere()
+	public boolean canSpawnHere()
     {
         return world.checkIfAABBIsClear(bb);
     }
 
     @Override
-	public int getTalkInterval()
+	public int getAmbientSoundInterval()
     {
         return 120;
     }
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java b/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
similarity index 80%
rename from src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
rename to src/main/java/net/minecraft/core/entity/animal/WolfMob.java
index 76adf674b..ac4f3abc3 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
+++ b/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
@@ -1,13 +1,14 @@
 package net.minecraft.core.entity.animal;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.projectile.EntityArrow;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.entity.projectile.ArrowProjectile;
+import net.minecraft.core.item.FoodItem;
+import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemArmor;
-import net.minecraft.core.item.ItemFood;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.util.collection.NamespaceID;
@@ -21,15 +22,15 @@ import net.minecraft.core.util.helper.DamageType;
 import java.util.*;
 
 // Referenced classes of package net.minecraft.src:
-//            EntityAnimal, DataWatcher, NBTTagCompound, World, 
-//            EntityPlayer, EntitySheep, AxisAlignedBB, Entity, 
-//            InventoryPlayer, ItemStack, Item, ItemFood, 
-//            MathHelper, EntityArrow, EntityLiving
+//            Animal, DataWatcher, NBTTagCompound, World,
+//            Player, SheepMob, AxisAlignedBB, Entity,
+//            InventoryPlayer, ItemStack, Item, FoodItem,
+//            MathHelper, ArrowProjectile, Mob
 
-public class EntityWolf extends EntityAnimal
+public class WolfMob extends Animal
 {
 
-    public EntityWolf(World world)
+    public WolfMob(World world)
     {
         super(world);
         looksWithInterest = false;
@@ -37,22 +38,22 @@ public class EntityWolf extends EntityAnimal
         setSize(0.8F, 0.8F);
         moveSpeed = 1.1F;
         scoreValue = 500;
+
+        if(!isWolfTamed()){
+            if(random.nextInt(100) == 0){
+                setWolfHeldItem(new ItemStack(Items.RECORD_DOG, 1));
+            }
+        }
     }
 
     @Override
-	protected void init()
+	protected void defineSynchedData()
     {
-        super.init();
+        super.defineSynchedData();
         entityData.define(15, ItemStack.NO_ITEM);
         entityData.define(16, (byte) 0);
         entityData.define(17, "");
         entityData.define(19, "");
-
-        if(!isWolfTamed()){
-            if(random.nextInt(100) == 0){
-                setWolfHeldItem(new ItemStack(Item.recordDog, 1));
-            }
-        }
     }
     @Override
     public boolean sendDeathMessage(Entity entityKilledBy){
@@ -75,8 +76,9 @@ public class EntityWolf extends EntityAnimal
     public void setArmor(ItemStack stack) {
         ArmorMaterial material = null;
         armor = stack;
-        if (stack != null && stack.getItem() instanceof ItemArmor && ARMOR_MATERIALS.containsValue(stack.getItem())){
-            material = ((ItemArmor) stack.getItem()).material;
+        //noinspection SuspiciousMethodCalls
+        if (stack != null && stack.getItem() instanceof IArmorItem && ARMOR_MATERIALS.containsValue(stack.getItem())){
+            material = ((IArmorItem) stack.getItem()).getArmorMaterial();
         }
         if (material == null) {
             entityData.set(19, "");
@@ -96,11 +98,11 @@ public class EntityWolf extends EntityAnimal
     {
         if(isWolfTamed())
         {
-            return "/assets/minecraft/textures/entity/wolf_tame/" + getSkinVariant() + ".png";
+            return "/assets/minecraft/textures/entity/wolf_tame/" + getTextureReference() + ".png";
         }
         else if(isWolfAngry())
         {
-            return "/assets/minecraft/textures/entity/wolf_angry/" + getSkinVariant() + ".png";
+            return "/assets/minecraft/textures/entity/wolf_angry/" + getTextureReference() + ".png";
         }
         else
         {
@@ -128,9 +130,9 @@ public class EntityWolf extends EntityAnimal
     @Override
     public boolean collidesWith(Entity entity)
     {
-        if (entity instanceof EntityPlayer)
+        if (entity instanceof Player)
         {
-            EntityPlayer player = (EntityPlayer) entity;
+            Player player = (Player) entity;
             return !player.username.equalsIgnoreCase(getWolfOwner()) || isWolfSitting();
         }
 
@@ -192,7 +194,7 @@ public class EntityWolf extends EntityAnimal
                         break;
                     }
                 }
-                Item item = ARMOR_MATERIALS.get(material);
+                Item item = ARMOR_MATERIALS.get(material).asItem();
                 setArmor(item.getDefaultStack());
             } else {
                 CompoundTag armorTag = tag.getCompound("Armor");
@@ -257,7 +259,7 @@ public class EntityWolf extends EntityAnimal
     }
 
     @Override
-    protected void dropFewItems()
+    protected void dropDeathItems()
     {
         if(getHeldItem() != null && getHeldItem().stackSize > 0) {
         	spawnAtLocation(getHeldItem(), 0.0f);
@@ -267,15 +269,15 @@ public class EntityWolf extends EntityAnimal
             spawnAtLocation(armor, 0);
             setArmor(null);
         }
-        super.dropFewItems();
+        super.dropDeathItems();
     }
 
     @Override
-	protected void updatePlayerActionState()
+	protected void updateAI()
     {
-        super.updatePlayerActionState();
+        super.updateAI();
 
-        if (getTarget() instanceof EntityItem)
+        if (getTarget() instanceof ItemEntity)
         {
             if (getTarget().isInWater() || getTarget().isInLava() || getTarget().isInWall() || !getTarget().onGround || getTarget().isRemoved())
             {
@@ -285,7 +287,7 @@ public class EntityWolf extends EntityAnimal
 
         if(!hasAttacked && !hasPath() && isWolfTamed() && vehicle == null)
         {
-            EntityPlayer entityplayer = world.getPlayerEntityByName(getWolfOwner());
+            Player entityplayer = world.getPlayerEntityByName(getWolfOwner());
             if(entityplayer != null)
             {
                 float f = entityplayer.distanceTo(this);
@@ -302,7 +304,7 @@ public class EntityWolf extends EntityAnimal
         if(entityToAttack == null && !hasPath())
         {
             if(!isWolfTamed() && world.rand.nextInt(100) == 0){
-                List nearbySheep = world.getEntitiesWithinAABB(EntitySheep.class, AABB.getBoundingBoxFromPool(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).expand(16D, 4D, 16D));
+                List nearbySheep = world.getEntitiesWithinAABB(SheepMob.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
                 if (!nearbySheep.isEmpty()) {
                     setTarget((Entity) nearbySheep.get(world.rand.nextInt(nearbySheep.size())));
                 }
@@ -311,11 +313,11 @@ public class EntityWolf extends EntityAnimal
         ItemStack heldItemSlot = getWolfHeldItem();
         if((heldItemSlot == null || heldItemSlot.itemID <= 0)) {
             List<Entity> triedItems = new ArrayList<>();
-            List<Entity> nearbyItems = world.getEntitiesWithinAABB(EntityItem.class, AABB.getBoundingBoxFromPool(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).expand(16D, 4D, 16D));
+            List<Entity> nearbyItems = world.getEntitiesWithinAABB(ItemEntity.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
             if (!nearbyItems.isEmpty()) {
                 while (triedItems.size() != nearbyItems.size())
                 {
-                    EntityItem item = (EntityItem) nearbyItems.get(world.rand.nextInt(nearbyItems.size()));
+                    ItemEntity item = (ItemEntity) nearbyItems.get(world.rand.nextInt(nearbyItems.size()));
                     if (triedItems.contains(item))
                     {
                         continue;
@@ -347,19 +349,19 @@ public class EntityWolf extends EntityAnimal
         if(hasCurrentTarget() && !hasPath() && !isWolfAngry())
         {
             Entity entity = getCurrentTarget();
-            if(entity instanceof EntityPlayer)
+            if(entity instanceof Player)
             {
-                EntityPlayer entityplayer = (EntityPlayer)entity;
+                Player entityplayer = (Player)entity;
                 ItemStack itemstack = entityplayer.inventory.getCurrentItem();
                 if(itemstack != null)
                 {
-                    if(!isWolfTamed() && itemstack.itemID == Item.bone.id)
+                    if(!isWolfTamed() && itemstack.itemID == Items.BONE.id)
                     {
                         looksWithInterest = true;
                     } else
-                    if(isWolfTamed() && (Item.itemsList[itemstack.itemID] instanceof ItemFood))
+                    if(isWolfTamed() && (Item.itemsList[itemstack.itemID] instanceof FoodItem))
                     {
-                        looksWithInterest = ((ItemFood)Item.itemsList[itemstack.itemID]).getIsWolfsFavoriteMeat();
+                        looksWithInterest = ((FoodItem)Item.itemsList[itemstack.itemID]).getIsWolfsFavoriteMeat();
                     }
                 }
             }
@@ -388,12 +390,12 @@ public class EntityWolf extends EntityAnimal
         if(entitiesNearWolf != null && entitiesNearWolf.size() > 0 && isAlive())
         {
             for (Entity entity : entitiesNearWolf) {
-                if(entity instanceof EntityItem && (this.getWolfHeldItem() == null || this.getWolfHeldItem().getItem() == null)){
-                    EntityItem entityItem = (EntityItem) entity;
+                if(entity instanceof ItemEntity && (this.getWolfHeldItem() == null || this.getWolfHeldItem().getItem() == null)){
+                    ItemEntity itemEntity = (ItemEntity) entity;
 
-                    if (entityItem.item != null && entityItem.item.stackSize > 0) {
-                        setWolfHeldItem(entityItem.item.copy());
-                        entityItem.item.stackSize = 0;
+                    if (itemEntity.item != null && itemEntity.item.stackSize > 0) {
+                        setWolfHeldItem(itemEntity.item.copy());
+                        itemEntity.item.stackSize = 0;
                         entity.outOfWorld();
 
                         break;
@@ -440,7 +442,7 @@ public class EntityWolf extends EntityAnimal
             if(timeWolfIsShaking > 0.4F)
             {
                 float f = (float) bb.minY;
-                int i = (int)(MathHelper.sin((timeWolfIsShaking - 0.4F) * 3.141593F) * 7F);
+                int i = (int)(MathHelper.sin((timeWolfIsShaking - 0.4F) * MathHelper.PI) * 7F);
                 for(int j = 0; j < i; j++)
                 {
                     double offX = (random.nextFloat() * 2.0F - 1.0F) * bbWidth * 0.5F;
@@ -473,12 +475,12 @@ public class EntityWolf extends EntityAnimal
         {
             f2 = 1.0F;
         }
-        return MathHelper.sin(f2 * 3.141593F) * MathHelper.sin(f2 * 3.141593F * 11F) * 0.15F * 3.141593F;
+        return MathHelper.sin(f2 * MathHelper.PI) * MathHelper.sin(f2 * MathHelper.PI * 11F) * 0.15F * MathHelper.PI;
     }
 
     public float getInterestedAngle(float f)
     {
-        return (field_25054_c + (field_25048_b - field_25054_c) * f) * 0.15F * 3.141593F;
+        return (field_25054_c + (field_25048_b - field_25054_c) * f) * 0.15F * MathHelper.PI;
     }
 
     @Override
@@ -504,9 +506,9 @@ public class EntityWolf extends EntityAnimal
         Path pathentity = world.getPathToEntity(this, entity, 16F);
         if(pathentity == null && f > 12F)
         {
-            int i = MathHelper.floor_double(entity.x) - 2;
-            int j = MathHelper.floor_double(entity.z) - 2;
-            int k = MathHelper.floor_double(entity.bb.minY);
+            int i = MathHelper.floor(entity.x) - 2;
+            int j = MathHelper.floor(entity.z) - 2;
+            int k = MathHelper.floor(entity.bb.minY);
             for(int l = 0; l <= 4; l++)
             {
                 for(int i1 = 0; i1 <= 4; i1++)
@@ -536,7 +538,7 @@ public class EntityWolf extends EntityAnimal
     public boolean hurt(Entity attacker, int i, DamageType type)
     {
         setWolfSitting(false);
-        if(attacker != null && !(attacker instanceof EntityPlayer) && !(attacker instanceof EntityArrow))
+        if(attacker != null && !(attacker instanceof Player) && !(attacker instanceof ArrowProjectile))
         {
             i = (i + 1) / 2;
         }
@@ -544,18 +546,18 @@ public class EntityWolf extends EntityAnimal
         {
             if(!isWolfTamed() && !isWolfAngry())
             {
-                if(attacker instanceof EntityPlayer)
+                if(attacker instanceof Player)
                 {
                     setWolfAngry(true);
                     entityToAttack = attacker;
                 }
-                if((attacker instanceof EntityArrow) && ((EntityArrow) attacker).owner != null)
+                if((attacker instanceof ArrowProjectile) && ((ArrowProjectile) attacker).owner != null)
                 {
-                    attacker = ((EntityArrow) attacker).owner;
+                    attacker = ((ArrowProjectile) attacker).owner;
                 }
-                if(attacker instanceof EntityLiving)
+                if(attacker instanceof Mob)
                 {
-                    List list = world.getEntitiesWithinAABB(EntityWolf.class, AABB.getBoundingBoxFromPool(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).expand(16D, 4D, 16D));
+                    List list = world.getEntitiesWithinAABB(WolfMob.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
                     Iterator iterator = list.iterator();
                     do
                     {
@@ -564,11 +566,11 @@ public class EntityWolf extends EntityAnimal
                             break;
                         }
                         Entity entity1 = (Entity)iterator.next();
-                        EntityWolf entitywolf = (EntityWolf)entity1;
+                        WolfMob entitywolf = (WolfMob)entity1;
                         if(!entitywolf.isWolfTamed() && entitywolf.entityToAttack == null)
                         {
                             entitywolf.entityToAttack = attacker;
-                            if(attacker instanceof EntityPlayer)
+                            if(attacker instanceof Player)
                             {
                                 entitywolf.setWolfAngry(true);
                             }
@@ -578,7 +580,7 @@ public class EntityWolf extends EntityAnimal
             } else
             if(attacker != this && attacker != null)
             {
-                if(isWolfTamed() && (attacker instanceof EntityPlayer) && ((EntityPlayer) attacker).username.equalsIgnoreCase(getWolfOwner()))
+                if(isWolfTamed() && (attacker instanceof Player) && ((Player) attacker).username.equalsIgnoreCase(getWolfOwner()))
                 {
                     return true;
                 }
@@ -606,7 +608,7 @@ public class EntityWolf extends EntityAnimal
     @Override
 	protected void attackEntity(Entity entity, float distance)
     {
-        if(entity instanceof EntityItem)
+        if(entity instanceof ItemEntity)
             return;
         if(distance > 2.0F && distance < 6F && random.nextInt(10) == 0)
         {
@@ -614,9 +616,9 @@ public class EntityWolf extends EntityAnimal
             {
                 double d = entity.x - x;
                 double d1 = entity.z - z;
-                float f1 = MathHelper.sqrt_double(d * d + d1 * d1);
-                xd = (d / (double)f1) * 0.5D * 0.80000001192092896D + xd * 0.20000000298023224D;
-                zd = (d1 / (double)f1) * 0.5D * 0.80000001192092896D + zd * 0.20000000298023224D;
+                float f1 = MathHelper.sqrt(d * d + d1 * d1);
+                xd = (d / (double)f1) * 0.5D * 0.80000001192092896D + xd * 0.2D;
+                zd = (d1 / (double)f1) * 0.5D * 0.80000001192092896D + zd * 0.2D;
                 yd = 0.40000000596046448D;
             }
         } else
@@ -651,18 +653,18 @@ public class EntityWolf extends EntityAnimal
     }
 
     @Override
-	public boolean interact(EntityPlayer entityplayer)
+	public boolean interact(Player entityplayer)
     {
         if (super.interact(entityplayer)) return true;
         ItemStack itemstack = entityplayer.inventory.getCurrentItem();
         if(!isWolfTamed())
         {
-            if(itemstack != null && itemstack.itemID == Item.bone.id && !isWolfAngry())
+            if(itemstack != null && itemstack.itemID == Items.BONE.id && !isWolfAngry())
             {
                 itemstack.consumeItem(entityplayer);
                 if(itemstack.stackSize <= 0)
                 {
-                    entityplayer.inventory.setInventorySlotContents(entityplayer.inventory.currentItem, null);
+                    entityplayer.inventory.setItem(entityplayer.inventory.currentItem, null);
                 }
                 if(!world.isClientSide)
                 {
@@ -685,9 +687,9 @@ public class EntityWolf extends EntityAnimal
             }
         } else
         {
-            if(itemstack != null && (Item.itemsList[itemstack.itemID] instanceof ItemFood))
+            if(itemstack != null && (Item.itemsList[itemstack.itemID] instanceof FoodItem))
             {
-                ItemFood itemfood = (ItemFood)Item.itemsList[itemstack.itemID];
+                FoodItem itemfood = (FoodItem)Item.itemsList[itemstack.itemID];
                 if(itemfood.getIsWolfsFavoriteMeat() && getHealth() < getMaxHealth())
                 {
                 	if (entityplayer.getGamemode().consumeBlocks())
@@ -695,16 +697,16 @@ public class EntityWolf extends EntityAnimal
                 		itemstack.stackSize--;
                 		if(itemstack.stackSize <= 0)
                 		{
-                			entityplayer.inventory.setInventorySlotContents(entityplayer.inventory.currentItem, null);
+                			entityplayer.inventory.setItem(entityplayer.inventory.currentItem, null);
                 		}                		
                 	}
-                    heal(((ItemFood)Item.foodPorkchopRaw).getHealAmount());
+                    heal(((FoodItem)Items.FOOD_PORKCHOP_RAW).getHealAmount());
                     return true;
                 }
             }
-            if (itemstack != null && itemstack.getItem() != null && itemstack.getItem() instanceof ItemArmor && entityplayer.username.equalsIgnoreCase(getWolfOwner())) {
-                ItemArmor itemArmor = (ItemArmor) itemstack.getItem();
-                if (itemArmor.material != null && ARMOR_MATERIALS.containsValue(itemArmor)) {
+            if (itemstack != null && itemstack.getItem() instanceof IArmorItem && entityplayer.username.equalsIgnoreCase(getWolfOwner())) {
+                IArmorItem armorItem = (IArmorItem) itemstack.getItem();
+                if (armorItem.getArmorMaterial() != null && ARMOR_MATERIALS.containsValue(armorItem)) {
                     if (armor != null) {
                         spawnAtLocation(armor, 0.0f);
                         setArmor(null);
@@ -713,7 +715,7 @@ public class EntityWolf extends EntityAnimal
                     if (entityplayer.getGamemode().consumeBlocks()) {
                         itemstack.stackSize--;
                         if (itemstack.stackSize <= 0) {
-                            entityplayer.inventory.setInventorySlotContents(entityplayer.inventory.currentItem, null);
+                            entityplayer.inventory.setItem(entityplayer.inventory.currentItem, null);
                         }
                     }
                     return true;
@@ -787,22 +789,6 @@ public class EntityWolf extends EntityAnimal
         }
     }
 
-    public float getTailRotation()
-    {
-        if(isWolfAngry())
-        {
-            return 88 * (MathHelper.PI / 180F);
-        }
-        else if(isWolfTamed())
-        {
-            return (0.55F - (float)(getMaxHealth() - getHealth()) * 0.02F) * MathHelper.PI;
-        }
-        else
-        {
-            return 36 * (MathHelper.PI / 180F);
-        }
-    }
-
     public String getWolfOwner()
     {
         return entityData.getString(17);
@@ -887,13 +873,13 @@ public class EntityWolf extends EntityAnimal
     private float timeWolfIsShaking;
     private float prevTimeWolfIsShaking;
     private ItemStack armor = null;
-    public static final Map<ArmorMaterial, ItemArmor> ARMOR_MATERIALS = new HashMap<>();
+    public static final Map<ArmorMaterial, IArmorItem> ARMOR_MATERIALS = new HashMap<>();
     static {
-        ARMOR_MATERIALS.put(ArmorMaterial.LEATHER, (ItemArmor) Item.armorChestplateLeather);
-        ARMOR_MATERIALS.put(ArmorMaterial.CHAINMAIL, (ItemArmor) Item.armorChestplateChainmail);
-        ARMOR_MATERIALS.put(ArmorMaterial.IRON, (ItemArmor) Item.armorChestplateIron);
-        ARMOR_MATERIALS.put(ArmorMaterial.GOLD, (ItemArmor) Item.armorChestplateGold);
-        ARMOR_MATERIALS.put(ArmorMaterial.DIAMOND, (ItemArmor) Item.armorChestplateDiamond);
-        ARMOR_MATERIALS.put(ArmorMaterial.STEEL, (ItemArmor) Item.armorChestplateSteel);
+        ARMOR_MATERIALS.put(ArmorMaterial.LEATHER,   (IArmorItem) Items.ARMOR_CHESTPLATE_LEATHER);
+        ARMOR_MATERIALS.put(ArmorMaterial.CHAINMAIL, (IArmorItem) Items.ARMOR_CHESTPLATE_CHAINMAIL);
+        ARMOR_MATERIALS.put(ArmorMaterial.IRON,      (IArmorItem) Items.ARMOR_CHESTPLATE_IRON);
+        ARMOR_MATERIALS.put(ArmorMaterial.GOLD,      (IArmorItem) Items.ARMOR_CHESTPLATE_GOLD);
+        ARMOR_MATERIALS.put(ArmorMaterial.DIAMOND,   (IArmorItem) Items.ARMOR_CHESTPLATE_DIAMOND);
+        ARMOR_MATERIALS.put(ArmorMaterial.STEEL,     (IArmorItem) Items.ARMOR_CHESTPLATE_STEEL);
     }
 }
